
#include <pspaudio.h>
#include "shared.h"
#include "sound.h"
#include "SMS.h"

typedef struct {
        short l, r;
} sample_t;

sample_t audioOut[2048];
int sndThid = 0;
static int SoundThread();
int soundPause = 1;

void SoundInit(void)
{	
	if(snd.sample_rate)
	{
		memset(audioOut, 0, 2048*sizeof(sample_t));

		sndThid = sceKernelCreateThread("SoundThread", SoundThread, 0x18, 0xFA0, 0, 0); 

		if(sndThid<0)
			return;

		sceKernelStartThread(sndThid,0,0);  
	}
}

void SoundTerm(void)
{
	if(sndThid)
	{
		sceKernelTerminateDeleteThread(sndThid);
		sndThid = 0;
	}
}

void SoundUpdate(void)
{
	if(SmsConfig.SoundEnabled)
	{
		int i;
		for(i = 0; i < snd.sample_count; ++i) 
		{
			audioOut[i].l = (snd.output[0][i]);
			audioOut[i].r = (snd.output[1][i]);
		}

		soundPause = 0;
	}
}

void SoundPause(void)
{
	soundPause = 1;
	
	//sceKernelSuspendThread(sndThid);
}

void SoundResume(void)
{
	soundPause = 0;

	//sceKernelResumeThread(sndThid);
}

static int SoundThread()
{
	int err=0;
	int sample_count = snd.sample_rate/snd.fps;
	int chan = sceAudioChReserve(PSP_AUDIO_NEXT_CHANNEL, PSP_AUDIO_SAMPLE_ALIGN(sample_count), PSP_AUDIO_FORMAT_STEREO);

	if(chan > 0)
	{
		for(;;)
		{
			if(!soundPause)
			{
				// Maybe this should be pspAudioOut rather than block
				sceAudioOutputPannedBlocking(chan, PSP_AUDIO_VOLUME_MAX, PSP_AUDIO_VOLUME_MAX, (void*)audioOut);
			}

			sceDisplayWaitVblankStart();
		}
	}
}
